//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de/frida
//**************************************************************************************************

//! \file  jsel.cpp
//! \brief Selection of spec/curve index j.

#include "defs.hpp"


#include "../readplus/ask.hpp"
#include "../trivia/vector_ops.hpp"

#include "olf.hpp"
#include "fsel.hpp"
#include "loop.hpp"
#include "obj.hpp"
#include "expr.hpp"
#include "xax_lex.hpp"

//! Interactive spectrum selection.

void JSelAsk( string quest, vector<int>& jLis )
{ // EMBEDDED_DIALOG
    FileIterator fiter(SFSel::instance()->sel());
    int nJmax = 0;
    while ( const COlo *f = fiter.next() )
        nJmax = std::max( nJmax, f->nJ() );

    if ( nJmax==1 ){
        jLis.resize(1);
        jLis[0] = 0;
    } else {
        string expr = wask( quest, triv::indices_to_s( jLis ) );
        RNode T = user_xaxparse( expr.c_str() );
        RObjVecInt v = T->to_index_list( nJmax );
        if (!v)
            throw S("not a valid index list");
        jLis = v->v;
    }
}
